--	************************************************************************
--
--	流星模型载入脚本 	v0.1
--	作者:	yish
--	日期:	2010-10-31
--	简介:	解析流星蝴蝶剑模型< *.gmc > 格式,载入3DSMAX
--	环境:	3DSMAX2009
--
--	更新记录:
--	-2010-10-31-----------------------------------------------------------
--	版本	0.1
--	增加:		1,实现导入
--
--	待做:
--			1,纹理未导入
--	************************************************************************



--print "--------		流星模型载入脚本 v0.1	-----------"
--print "--------		by Yish   		-----------"
--print "--------		2010-10-31   		-----------"


struct LXMAT
(
    Id,     tex,    col,    amb,    dif,    spec,   emis,   opac,   opt,    twoside
 --   Texture   nm011b01.jpg
 --   ColorKey  0 0 0 0
 --   Ambient   1.000 1.000 1.000
 --   Diffuse   1.000 1.000 1.000
 --   Specular  1.000 1.000 1.000
 --   Emissive  0.000 0.000 0.000
 --   Opacity   1.000
 --   Option    NONE
 --   TwoSide   FALSE
)	-- end struct LXMAT



struct LXBONE
(
	 	vpos,	vrot,	boneName,		boneId,	parentName,	parentId,		child,	type,

								 -- 读入 骨骼块定义格式	,每个块定义如下
								 /*************************
									 bone b
									{
									  parent d_base
									  pivot  0.000 -0.091 21.645
									  quaternion -0.70711 0.00000 0.00000 0.70711
									  children 1
									}
								***************************/
	fn	get_bone	in_fileBnc=
	(				
			for m =1 to 7 do
			(
				line=readline  in_fileBnc		 	-- 读入一行
				subline = filterString  line " "		-- 用空格分解为文本数组
					
				case subline[1] of 
				(
					"bone"	:	(	boneName = 	subline[2];	type = 1	)	--1代表bone
					"Dummey"	:	(	boneName = 	subline[2];	type = 2	)	--2代表dummey

					"{"		:	continue
					"parent"	:	parentName = subline[2]
					"pivot"	:	vpos = 	 [ ( subline[2] as float),	(subline[3] as float), (subline[4] as float) ]		-- 取得 骨骼坐标
					"quaternion"	:	vrot =  quat ( subline[3] as float *1.0) 	(subline[4] as float *1)  (subline[5] as float *1)  (subline[2] as float *1) 	
					"children"	:	child = subline[2] as integer
					"}"		:	exit		--	必须用exit,不管上面是否满6行,只要见到 "}" 即结束
				)--end case
				
			)--end for
	)-- end fn get_bone

)--end struct LXBONE

struct LXOBJ	
(

	Id,  verts = #(),	faces = #(),	face_mat =#(),	uvs =#(),	bone_ids =#(),      bone_v_count =#(),	weight_array =#(),	
    groups = #(), mats = #(),  num_mat,   num_vert,  num_face,  skin_name,

--========================================================================================
--                                      取子模型名称
--========================================================================================
    fn  getSkinName in_file=
	(
                                    while not eof in_file do 	                -- read until reach end of file
                                    (
                                        line=   readline  in_file 	            -- 读入一行
                                        subline = filterString  line " "		-- 用空格分解为文本数组
                                        if subline[1] == "#" do continue 	    -- 跳过注释行
                                        
                                        if   subline[1] == "Object"   then 
                                            (  
                                                skin_name = subline[2]             --  取得skin名字
										print 	("已取得名称 =" + skin_name)
                                                exit
                                            )
                                        else 
                                            continue
                                    )
    ),
--========================================================================================
--                                      取材质
--========================================================================================
    fn  getSkinMats in_file=
	(
                                while not eof in_file do 	                -- read until reach end of file
                                (
                                   line=   readline  in_file 	            -- 读入一行
                                    subline = filterString  line " "		-- 用空格分解为文本数组
                                    if subline[1] == "#" do continue 	    -- 跳过注释行
                                        
                                    if  ( subline[1] == "Materials:") then 
                                            (  
                                                num_mat = subline[2]as integer             --  取得skin名字
                                                print 	("已取得材质数量 =" + num_mat as string)
										 exit
                                            )
                                    else 
                                        continue
                                )
                                
                                --==================取 每个材质========= ============
                                for i = 1 to num_mat do
                                (
								for m= 1 to 10 do
	                                 (
								   line=readline  in_file 	 
	                                    subline = filterString  line " "	
	                                    
		                                    case  subline[1] of 
		                                    (
		                                        "Material"  :   mats[i] =  ( LXMAT     Id:i  )    --创建一个材质
		                                        
		                                        "Texture"   :   mats[i].tex =   subline[2]      --取纹理名
		                                        
		                                        "ColorKey"  :   mats[i].col =   #(subline[2] as integer , subline[3] as integer , subline[4] as integer ,  subline[5] as integer )   -- ColorKey  0 0 0 0
		                                        
		                                        "Ambient"  :   mats[i].amb =   #(subline[2] as float , subline[3] as float , subline[4] as float )  
		                                        
		                                        "Diffuse"  :   mats[i].dif =   #(subline[2] as float , subline[3] as float , subline[4] as float )   
		                                        
		                                        "Specular"  :   mats[i].spec =   #(subline[2] as float , subline[3] as float , subline[4] as float )   
		                                    
		                                        "Emissive"  :   mats[i].emis =   #(subline[2] as float , subline[3] as float , subline[4] as float )   
		                                    
		                                        "Opacity"  :   mats[i].opac =   subline[2]as float
		                                        
		                                        "Option"  :   mats[i].opt =     subline[2]      -- NONE
		                                        
		                                        "TwoSide"  :   mats[i].twoside =     subline[2]      -- FALSE
		                                        
		                                    )	 --end case
										
								)--end for
                                )
                         
     ) , 
--========================================================================================
--                                      取顶点
--========================================================================================
    fn  getSkinVerts in_file=(
                                while not eof in_file do 	                -- read until reach end of file
                                (
                                   line=   readline  in_file 	            -- 读入一行
                                    subline = filterString  line " "		-- 用空格分解为文本数组
                                    if subline[1] == "#" do continue 	    -- 跳过注释行
                                        
                                    if  ( subline[1] == "Vertices") then 
                                            (  
                                                num_vert = subline[2]as integer             --  取得顶点数
                                                format " 取得顶点数=     %   \n"     num_vert

                                              num_face = subline[4]as integer             --  取得顶点数
                                                format " 取得三角面数=     %   \n"     num_face
                                                exit
                                            )
                                    else 
                                        continue
                                )
                                
                                --==================取 每个顶点========= ============
                                for v = 1 to num_vert do
                                (
                                    line=readline  in_file 	 
                                    subline = filterString  line " \t"	
                                    
                                    ---------------     读入 顶点格式	每个顶点如下
                                    ---------------    v   4.009  -0.445  29.497 vt 0.794 0.765 Bones 3 11 0.51823 15 0.31075 14 0.17102
					-----------    v   0.743  -2.853  0.209 n  0.080 -0.114  0.990 c 254 211 157 255 t 0.26085 0.04720
                                    
                                    append verts 	[ (subline[2]as float) ,(subline[3]as float), (subline[4]as float)	]	--读入顶点 坐标
                                    append uvs 		[ (subline[15]as float) ,(subline[16]as float), 	0,0	]		--	uv坐标是  Point3 类型,				--读入纹理 坐标


                                 )--end for
								 print "-----------子obj顶点读取完成----------"
                                --==================取 每个三角面========= ============
                                ---------------     读入 顶点格式	每个顶点如下
				---------  f 0 0 1 2	 0.194 -0.296  0.935
                                for v = 1 to num_face do
                                (
                                    line=readline  in_file 	 
                                    subline = filterString  line " \t"
                                  
									append face_mat		((subline[2]as integer)+1)
                                    append faces 		[ (subline[3]as integer)+1 ,(subline[4]as integer)+1, (subline[5]as integer)+1	]
	

                                )

                         
	)  -- end fn


)  -- end struct LXOBJ




global	 boneCount 	
global	dummeyCount	
--========================================================================================
--                                      读骨骼总数
--========================================================================================
fn	readBoneNum		in_fileBnc=
(
		while not eof in_fileBnc do 	-- read until reach end of file
		( 
			line=	readline  in_fileBnc 	-- 读入一行
			subline = filterString  line " "		 	-- 用空格分解为文本数组
			if subline[1] == "#" do continue 	     -- 跳过注释行

			-- 寻找骨骼数量,此行定义如下: 	Bones: 30 Dummey: 6
			if subline[1] != "Bones:" then continue else exit	
		)
		---------------------		读入骨骼数		----------------------------
		boneCount = subline[2]as integer			--读入 骨骼数
		dummeyCount = subline[4]as integer			--读入 Dummey 数
		print ("骨骼总数=	" + (boneConut as string) + ";    Dummey总数= "+ (dummeyCount as string) 		)	
		
) 


global	num_skins	

global  num_SceneObjects	--场景对象总数
global  num_DummeyObjects	--动态对象总数
--======================================================================================== 
--                                     读取模型
--========================================================================================
fn	readLxObj		in_file=
(
	local subline
	
		while not eof in_file do 	-- read until reach end of file
		( 
				line=readline  in_file 	-- 读入一行
				subline = filterString  line " "		-- 用空格分解为文本数组
				if subline[1] == "#" do continue 	-- 跳过注释行, skip to next line
				if  ( subline[1] == "SceneObjects" and subline[3] == "DummeyObjects" ) then 
		        (  
					num_SceneObjects = subline[2] as integer       --取得 场景对象总数
					num_DummeyObjects = subline[4] as integer       --取得 动态对象总数
		            exit
		         )
			
		) 
	format " 取得 场景对象总数=     % ，  取得 动态对象总数=     %   \n"      num_SceneObjects 	num_DummeyObjects
      
 -- line=readline  in_file 				-- 跳过一行(顶点和面 总数）	Vertices 157 Faces 170


	myobj = #()
	
	for i=1 to  num_SceneObjects   do
	(
        --      开始遍历所有子模型,通常 流星低模只有1个模型
       -- line=readline  in_file 				-- 跳过一行	"{"	

        myobj[i] = LXOBJ Id:i               --创建一个子模型
        myobj[i].getSkinName    in_file     -- 取模型名称
	  line=readline  in_file 				-- 跳过一行	"{"	

		print 	("--------------- 	OBJ name = " + myobj[i].skin_name)

--       myobj[i].getSkinMats    in_file     --取材质
--		print 	("--------------- 	材质数量  = " + ( myobj[i].mats.count as string) )


        myobj[i].getSkinVerts   in_file     --取顶点
       -- myobj[i].getSkinFaces   in_file     --取面
        
	   line=readline  in_file 				-- 跳过一行	"}"			-- 至此取得一个静态子模型
	  print("-------- 取得一个OBJ 成功 ----------")
	)-- end for
	  
	  return	myobj
) -- end fn readLxObj



--========================================================================================
--                                      Main()
-- 分析gmc格式
--========================================================================================
fn 	mainFunc  argName=
(

delete $*


--------------------		读入 skc 模型		-----------------------

--in_name = ((GetDir #export)+"/../scripts/SMDImporter/p9_300.skc") 

lx_objs 	= 	#()



if doesFileExist  argName then

--if in_name != undefined then
( 
	in_name = argName
	a_file = openFile in_name 	
	
	if a_file != undefined then
	(
		print ("   ---	开始读入流星[gmc模型]文件:	"+ in_name)
		lx_objs = readLxObj a_file	
		close a_file 
		print ("   ---	流星[gmc模型]文件读入完毕:	"+ in_name)	 
	)

)else(
	return NULL
)-- end if 	





--------------------		创建模型		-----------------------
lx_meshs	=#()

print ("	***		开始创建模型")
for	i = 1 to lx_objs.count	do		-- 为每个模型创建
(
	
     lx_meshs[i]  =      mesh    name:lx_objs[i].skin_name	 vertices:lx_objs[i].verts  faces:lx_objs[i].faces  materialIDs: lx_objs[i].face_mat	tverts:lx_objs[i].uvs
		
	/*	
		--建造材质
		    meditmaterials[1].ambient= lx_meshs[i].amb
		    meditmaterials[1].diffuse=  lx_meshs[i].dif
		    meditmaterials[1].shaderbyname=  lx_meshs[i].name
		    meditmaterials[1].specular=  lx_meshs[i].spec
		    meditmaterials[1].specularlevel=  lx_meshs[i].specularlever
		    meditmaterials[1].glossiness=_material_glossiness
		    meditmaterials[1].selfillumcolor=_Material_SelfillumColor
		    meditmaterials[1].selfillumamount=_Material_SelfillumAmount
		    meditmaterials[1].diffuseMapEnable=true
		    bmp =bitmaptexture filename:  lx_meshs[i].tex
		    meditmaterials[1].diffusemap=bmp
	*/
		
		--	meshop.setMapSupport lx_meshs[i]  0 true
    		--	meshop.setMapSupport lx_meshs[i]  1 true
				BUILDTVFACES 	lx_meshs[i]	-- FALSE
		setMeditMaterial 1 (standardMaterial selfIllumAmount:100) 
		--13. Build the faces
  
         -- lx_meshs[i].materialIDs = #(0,1)
        --14. Set the UVW coordinates to the faces.
         for f = 1 to lx_objs[i].faces.count do
         (
            setFaceMatID 	lx_meshs[i] 	f 	2
	    SETTVFACE	 	lx_meshs[i] 	f	lx_objs[i].faces[f]
         )
		
		--lx_meshs[i].Material=		getMeditMaterial 1
		--lx_meshs[i].material=meditmaterials[2]
	
		     

		update lx_meshs[i]
 )-- end for
 print ("	***		创建模型完毕")
------------------------------------------------------------------------
	
	disableSceneRedraw()	---------   取消重画, 可以提高速度,必须再用 enableSceneRedraw() 打开重画


	enableSceneRedraw()	---------------- 充许重画

	
)	-- end function mainFunc

--=======================================================================
--				Main	UI
--======================================================================
fn  getLxPath  cfgPath=
(
	fname = getOpenFileName types:"流星GMC文件 (*.gmc)|*.gmc|All (*.*)|*.*|" caption:"请选择流星蝴蝶剑gmc文件"
	if fname == undefined then return NULL
	lxPath = getFilenamePath fname	--取得流星主目录
	
	out_cfg_file = createfile 	cfgPath
	-- 创建配置文件
	if out_cfg_file == undefined then return NULL
	format "%\n"  lxPath  to: out_cfg_file
	close out_cfg_file 
	-- 结束创建
	fs= getFiles (lxPath + "\*.gmc") 
	return fs
)

rollout PrintRollout "流星蝴蝶剑GMC模型导入 v0.2" width:486 height:342 -- by Yish
(
 
	--button printbtn "导入模型" pos:[350,10] width:124 height:68
	--GroupBox grp1 "关于:" pos:[5,2] width:316 height:77
	--label titleLabel "流星蝴蝶剑 gmc模型导入工具v0.1" pos:[73,19] width:193 height:18
	--HyperLink add0 "访问网站" pos:[96,41] width:89 height:15 address:"http://www.lx766.com/bbs/read.php?tid=212&page=1&toread=1#tpc" color:(color 0 0 255) hovercolor:(color 255 0 0)
	--label txtdata "2010-10-31" pos:[229,62] width:78 height:13
	--listbox lbx1 "选择文件" pos:[7,83] width:472 height:19
	--label lbl12 "by Yish" pos:[232,42] width:59 height:16

	button printbtn "导入模型" pos:[344,300] width:124 height:32
	button PathBtn "添加路径" pos:[200,300] width:124 height:32

	GroupBox grp1 "" pos:[6,0] width:474 height:288

	label titleLabel "By yish" pos:[8,322] width:50 height:16

	HyperLink add0 "To Lxres.com" pos:[58,322] width:124 height:16 address:"www.lxres.com" color:(color 94 234 255) hovercolor:(color 255 0 0)

	--label txtdata "2010-5-1" pos:[249,48] width:54 height:13

	listbox lbx1 "选择文件（双击文件导入）" pos:[16,16] width:454 height:20

	on PrintRollout open do
	(		
	
	config_name = "lx2max_gmc.config"
	
	cfg_fname= ((GetDir #import)+"/"+config_name)
	
	
	
	if  doesFileExist cfg_fname	then	-- 如果文件存在
	
	(
	
		in_text = openfile  cfg_fname --打开配置文件
	
		--skipToString in_text "="
	
		while not eof in_text do
	
		( 
	
			lxPath = readline in_text
	
			exit
	
		) 
	
		close in_text 
	
	
	
		file_array = getFiles (lxPath + "\*.gmc") 
	
		if file_array == undefined then return NULL
	
		for lf in file_array do
	
		(
	
			tmp = lbx1.Items 
	
			append tmp  lf
	
			lbx1.Items = tmp
	
			--print lf
	
		)
	
	)else
	
	(
	
		file_array = getLxPath 		cfg_fname
	
		if file_array == undefined then return NULL
	
		for lf in file_array do
	
		(
	
			tmp = lbx1.Items 
	
			append tmp  lf
	
			lbx1.Items = tmp
	
			print lf
	
		)
	
	)
	
	
	)
	on printbtn pressed do
	(
	
	--mainFunc()
		
		retFile = lbx1.Items[ lbx1.selection ]
		if( retFile != undefined )then 
		(	mainFunc retFile	--	打开双击的文件
	--messagebox "此按钮功能暂时无效, 请双击列表框中的模型文件导入(注意是 *.gmc 文件!)"
		)
	
	)
	on PathBtn pressed do
	(
	
		config_name = "lx2max_gmc.config"
		cfg_fname= ((GetDir #import)+"/"+config_name)

		file_array = getLxPath 		cfg_fname
	
		if file_array == undefined then return NULL
				
		for lf in file_array do
	
		(
	
			tmp = lbx1.Items 
	
			append tmp  lf
	
			lbx1.Items = tmp
	
			print lf
				
		)
	
	)
	on lbx1 doubleClicked sel do
	(
	    retFile = lbx1.Items[ lbx1.selection ]
		mainFunc retFile	--	打开双击的文件
	)
)
createDialog PrintRollout